using System;
using System.Threading;
using System.Threading.Tasks;
using Avalonia.Controls;
using Avalonia.Interactivity;
using Avalonia.Media;
using Avalonia.Threading;
using 山海奇闻录.ViewModels;

namespace 山海奇闻录.Views;

public partial class MainView : UserControl
{
    private const int MainBoxNum = 3;
    private int CurImgIndex;
    
    private Task backgroundTask;

    private double WindowWidth;
    private double WindowHeight;
    
    public MainView()
    {
        InitializeComponent();

        //获取程序的宽高
        this.Loaded += GetWindowBodySize;

        //打开侧边栏
        this.OpenPushWindow.Click += OpenPushWindowHandler;
        //关闭侧边栏
        this.ClosePushWindow.Click += ClosePushWindowHandler;
    }
    private void InitPushWindow()
    {
        var NewTransForm = new TranslateTransform
        {
            X = (-1 * WindowWidth), // 设置 X 坐标偏移
            Y = (0 * WindowHeight)   // 设置 Y 坐标偏移
        };
        this.PushWindow.RenderTransform = NewTransForm;
    }

    private void InitLunBoTu()
    {
        //设置轮播图宽高
        this.MainBox.Width = (WindowWidth - 12);
        this.MainBox.Height = (WindowHeight / 3.5);
        
        this.MainImages1.Width = (WindowWidth - 12);
        this.MainImages1.Height = (WindowHeight / 3.5);
        this.MainImages2.Width = (WindowWidth - 12);
        this.MainImages2.Height = (WindowHeight / 3.5);
        this.MainImages3.Width = (WindowWidth - 12);
        this.MainImages3.Height = (WindowHeight / 3.5);
    }
    
    private void GetWindowBodySize(object sender, RoutedEventArgs e)
    {
        WindowWidth = this.Bounds.Width;
        WindowHeight = this.Bounds.Height;

        InitLunBoTu();
            
        InitPushWindow();
        
        StartSwitchMainImageBox();
    }

    private async void OpenPushWindowHandler(object? sender, RoutedEventArgs e)
    {
        await OpenPushWindowExecAsync();
    }

    private async Task OpenPushWindowExecAsync()
    {
        var NewTransForm = new TranslateTransform
        {
            X = (-1 * WindowWidth), // 设置 X 坐标偏移
            Y = (0 * WindowHeight)   // 设置 Y 坐标偏移
        };

        for (int i = 0; i < (WindowWidth / 10) - 1; i++)
        {
            NewTransForm.X += 10;
            NewTransForm.Y = 0;

            // 使用异步延迟，避免阻塞 UI 线程
            await Task.Delay(1);

            // 直接更新 UI
            this.PushWindow.RenderTransform = NewTransForm;
        }
        
        NewTransForm.X = 0;
        NewTransForm.Y = 0;
        
        this.PushWindow.RenderTransform = NewTransForm;
    }

    private async Task ClosePushWindowExec()
    {
        var NewTransForm = new TranslateTransform
        {
            X = (0 * WindowWidth), // 设置 X 坐标偏移
            Y = (0 * WindowHeight)   // 设置 Y 坐标偏移
        };
        
        for (int i = 0; i < (WindowWidth / 10) - 1; i++)
        {
            NewTransForm.X -= 10;
            NewTransForm.Y = 0;
            
            // 使用异步延迟，避免阻塞 UI 线程
            await Task.Delay(1);

            // 直接更新 UI
            this.PushWindow.RenderTransform = NewTransForm;
        }
        
        NewTransForm.X = (-1 * WindowWidth);
        NewTransForm.Y = 0;
        
        this.PushWindow.RenderTransform = NewTransForm;
    }  
    private async void ClosePushWindowHandler(object? sender, RoutedEventArgs e)
    {
        await ClosePushWindowExec();
    }
    
    private void StartSwitchMainImageBox()
    {
        backgroundTask = Task.Run(async () => await BackgroundTaskAsync());
    }
    
    private async Task BackgroundTaskAsync()
    {
        int cnt = 0;
        while (true)
        {
            await Task.Delay(1000); // 每秒执行一次
            // for (int i = 0; i < CurImgIndex; i++)
            // {
            //     // 更新 UI
            //     Dispatcher.UIThread.InvokeAsync(() =>
            //     {
            //         this.Fuck.Text = cnt.ToString();
            //         cnt += 1;
            //         if (cnt >= 3)
            //         {
            //             cnt = 0;
            //         }
            //     });
            //     
            //     
            // }
        }
    }
    
    //轮播图上一张
    void MainImageBoxPre()
    {
        
    }
    
    //轮播图上一张
    void MainImageBoxNext()
    {
        
    }
}
